--------------------------------------------
-- Function that replace Blizzard's function
--------------------------------------------
-- Modified by Celdor, as found in QuestIon by Celdor
-- This is Blizzard's function as of 4/19/2005 (1300)
-- Specific changes are noted within the function

function SFBDisplayItems_ToggleDropDownMenuUpdate_ToggleDropDownMenu(level, value, dropDownFrame, anchorName, xOffset, yOffset)
	if ( not level ) then
		level = 1;
	end
	UIDROPDOWNMENU_MENU_LEVEL = level;
	UIDROPDOWNMENU_MENU_VALUE = value;
	local listFrame = getglobal("DropDownList"..level);
	local listFrameName = "DropDownList"..level;
	
	local tempFrame;
	local point, relativePoint, relativeTo;
	if ( not dropDownFrame ) then
		tempFrame = this:GetParent();
	else
		tempFrame = dropDownFrame;
	end
	
	
	
	if ( listFrame:IsVisible() and (UIDROPDOWNMENU_OPEN_MENU == tempFrame:GetName()) ) then
		listFrame:Hide();
	else
		-- Hide the listframe anyways since it is redrawn OnShow() 
		listFrame:Hide();
		
		-- Frame to anchor the dropdown menu to
		local anchorFrame;

		-- Display stuff
		-- Level specific stuff
		if ( level == 1 ) then
			if ( not dropDownFrame ) then
				dropDownFrame = this:GetParent();
			end
			UIDROPDOWNMENU_OPEN_MENU = dropDownFrame:GetName();
			listFrame:ClearAllPoints();
			-- If there's no specified anchorName then use left side of the dropdown menu
			if ( not anchorName ) then
				-- See if the anchor was set manually using setanchor
				if ( dropDownFrame.xOffset ) then
					xOffset = dropDownFrame.xOffset;
				end
				if ( dropDownFrame.yOffset ) then
					yOffset = dropDownFrame.yOffset;
				end
				if ( dropDownFrame.point ) then
					point = dropDownFrame.point;
				end
				if ( dropDownFrame.relativeTo ) then
					relativeTo = dropDownFrame.relativeTo;
				else
					relativeTo = UIDROPDOWNMENU_OPEN_MENU.."Left";
				end
				if ( dropDownFrame.relativePoint ) then
					relativePoint = dropDownFrame.relativePoint;
				end
			elseif ( anchorName == "cursor" ) then
				relativeTo = "UIParent";
				local cursorX, cursorY = GetCursorPosition();
				if ( not xOffset ) then
					xOffset = 0;
				end
				if ( not yOffset ) then
					yOffset = 0;
				end
				xOffset = cursorX + xOffset;
				yOffset = cursorY + yOffset;
------------------------------------------------------------
-- CHANGE: The anchorName must be set to the UIParent when setting based on the cursor
-- New code:
				anchorName = "UIParent";
-- :CHANGE
------------------------------------------------------------
			else
				relativeTo = anchorName;
			end
			if ( not xOffset or not yOffset ) then
				xOffset = 8;
				yOffset = 22;
			end
			if ( not point ) then
				point = "TOPLEFT";
			end
			if ( not relativePoint ) then
				relativePoint = "BOTTOMLEFT";
			end
			listFrame:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset);
		else
			if ( not dropDownFrame ) then
				dropDownFrame = getglobal(UIDROPDOWNMENU_OPEN_MENU);
			end
			listFrame:ClearAllPoints();
			-- If this is a dropdown button, not the arrow anchor it to itself
			if ( strsub(this:GetParent():GetName(), 0,12) == "DropDownList" and strlen(this:GetParent():GetName()) == 13 ) then
				anchorFrame = this:GetName();
			else
				anchorFrame = this:GetParent():GetName();
			end
			listFrame:SetPoint("TOPLEFT", anchorFrame, "TOPRIGHT", 0, 0);
		end
		
		-- Change list box appearance depending on display mode
		if ( dropDownFrame and dropDownFrame.displayMode == "MENU" ) then
			getglobal(listFrameName.."Backdrop"):Hide();
			getglobal(listFrameName.."MenuBackdrop"):Show();
		else
			getglobal(listFrameName.."Backdrop"):Show();
			getglobal(listFrameName.."MenuBackdrop"):Hide();
		end

		UIDropDownMenu_Initialize(dropDownFrame, dropDownFrame.initialize, nil, level);
		-- If no items in the drop down don't show it
		if ( listFrame.numButtons == 0 ) then
			return;
		end

		-- Check to see if the dropdownlist is off the screen, if it is anchor it to the top of the dropdown button
		listFrame:Show();
		-- Hack since GetCenter() is returning coords relative to 1024x768
		local x, y = listFrame:GetCenter();
		-- Hack will fix this in next revision of dropdowns
		if ( not x or not y ) then
			listFrame:Hide();
			return;
		end
		-- Determine whether the menu is off the screen or not
		local offscreenY, offscreenX;
		if ( (y - listFrame:GetHeight()/2) < 0 ) then
			offscreenY = 1;
		end

------------------------------------------------------------
-- CHANGE: Since GetCenter returns coords relative to 1024x768, the right bound is 
-- always 1024 not what the current GetScreenWidth returns.
-- Original code: if ( x + listFrame:GetWidth()/2 > GetScreenWidth() ) then

-- New code:
		if ( x + listFrame:GetWidth()/2 > 1024 ) then

-- :CHANGE
------------------------------------------------------------
			offscreenX = 1;		
		end

		
		--  If level 1 can only go off the bottom of the screen
		if ( level == 1 ) then
------------------------------------------------------------
-- CHANGE: Make sure level 1 menus don't go off the screen to the right or bottom.
-- Original code:
-- if ( offscreenY ) then
--	listFrame:ClearAllPoints();
--	listFrame:SetPoint("BOTTOMLEFT", anchorName, "TOPLEFT", xOffset, -yOffset);
-- end

-- New code:

			-- if ( anchorName ) then
	

		
				-- Based on Blizzard's code for the other menu levels
				-- Now the first level of a drop down menu can't be off screen
				if ( offscreenY ) then
					if ( offscreenX ) then
						-- Off the bottom and right of the screen
						listFrame:ClearAllPoints();
						listFrame:SetPoint("BOTTOMRIGHT", anchorName, "BOTTOMLEFT", xOffset, yOffset);
					else
						-- Off the bottom of the screen
						listFrame:ClearAllPoints();
						listFrame:SetPoint("BOTTOMLEFT", anchorName, "BOTTOMLEFT", xOffset, yOffset);
					end
				else
					if ( offscreenX ) then
						-- Off the right of the screen
						listFrame:ClearAllPoints();
						listFrame:SetPoint("TOPRIGHT", anchorName, "BOTTOMLEFT", xOffset, yOffset);
						
					-- else
						-- Normal, so do nothing
					end
				end
			-- end
-- :CHANGE
------------------------------------------------------------
		else
			local anchorPoint, relativePoint, offsetX, offsetY;
			if ( offscreenY ) then
				if ( offscreenX ) then
					anchorPoint = "BOTTOMRIGHT";
					relativePoint = "BOTTOMLEFT";
					offsetX = 0;
					offsetY = -14;
				else
					anchorPoint = "BOTTOMLEFT";
					relativePoint = "BOTTOMRIGHT";
					offsetX = 0;
					offsetY = -14;
				end
			else
				if ( offscreenX ) then
					anchorPoint = "TOPRIGHT";
					relativePoint = "TOPLEFT";
					offsetX = 0;
					offsetY = 14;
				else
					anchorPoint = "TOPLEFT";
					relativePoint = "TOPRIGHT";
					offsetX = 0;
					offsetY = 14;
				end
			end
			listFrame:ClearAllPoints();
			listFrame:SetPoint(anchorPoint, anchorFrame, relativePoint, offsetX, offsetY);
------------------------------------------------------------
-- CHANGE: In some cases a long menu that would have been off screen low was set to avoid that but would
-- go off screen high due to its height. I attempt to place the menu in the middle. Not a perfect solution,
-- but it should help in most cases. Also, I didn't want to change any default behaviors unless the drop 
-- down menu was off the screen.
-- New code:
			local x2, y2 = listFrame:GetCenter();
			local stilloffscreenY;
			-- 768 or GetScreenHeight?
			if ( (y2 + listFrame:GetHeight()/2) > 768 ) then
				if ( offscreenX ) then
					anchorPoint = "RIGHT";
					relativePoint = "BOTTOMLEFT";
					offsetX = 0;
					offsetY = -14;
				else
					anchorPoint = "LEFT";
					relativePoint = "BOTTOMRIGHT";
					offsetX = 0;
					offsetY = -14;
				end
				listFrame:ClearAllPoints();
				listFrame:SetPoint(anchorPoint, anchorFrame, relativePoint, offsetX, offsetY);
			end
-- :CHANGE
------------------------------------------------------------
		end
	end
end